# https://wiki.fysik.dtu.dk/it/Exchange_IMAP_Email#exchange-ldap-address-book
"""
https://serverfault.com/questions/153526/how-can-i-find-the-ldap-server-in-the-dns-on-windows


"""
from ldap3 import Server, Connection, ALL, NTLM, SIMPLE, SASL
from ldap3 import ObjectDef
from pathlib import Path

if __name__ == "__main__":

    home = str(Path.home())
    server = Server('ait-padfdc20.win.dtu.dk', use_ssl=True)
    with open(home + "/.passw", 'r') as f:
        passw = f.read()

    conn = Connection(server, user="win\\tuhe", password=passw, authentication=SIMPLE)
    bound = conn.bind()
    print("Did bind?", bound)
    who = conn.extend.standard.who_am_i()
    print("Who?", who)

    # person = ObjectDef('inetOrgPerson')
    # import ldap3
    # ldap3.Reader(conn, person, 'member=CN=tuhe,OU=xxx,OU=xxxxxx,DC=mydomain,DC=com', 'DC=win,DC=dtu,DC=dk').search()
    # conn.extend.standard.paged_search

    # con = ldap.initialize('ldap://192.168.16.12:38')

    # user_dn = r"Administrator@foo.com"
    # password = "bar"

    criteria = "(&(objectClass=user)(sAMAccountName=tuhe))"
    # attributes = ['displayName', 'company']
    base = 'DC=win,DC=dtu,DC=dk'

    sr = conn.extend.standard.paged_search(base, search_filter=criteria)
    sr = list(sr)
    for r in sr:
        print(r)
    print(sr)
    print( list(conn.search(base, search_filter=criteria)) )


    sr = list(sr)



    # try:
    #     con.simple_bind_s(user_dn, password)
    #     res = con.search_s("CN=Users,DC=foo,DC=com", ldap.SCOPE_SUBTREE, '(objectClass=User)')
