def dump_data(base):
    data = {}
    fls = [f for f in glob.glob(base +"/**/*.*", recursive=True) if f.split(".")[-1] in ["py", "txt", "shell"]]
    import os

    # fls = [(f, ) for f in fls]
    for file in fls:
        with open(file, 'r') as f:
            k = os.path.relpath(file, base).replace(os.sep, "_").replace(".", "_")
            data[k] = f.read()
    return data


if __name__ == "__main__":
    # Snip the examples directory.
    from snipper import snip_dir
    import glob
    import jinja2

    snip_dir("../examples", output_dir="./snips")
    snip_dir("samples", output_dir="./snips")

    data = dump_data("./snips")

    from jinjafy.bibliography_maker import make_bibliography
    bib = make_bibliography("../setup.py", "./")

    from unitgrade.utils import Capturing, Capturing2
    import os
    import subprocess
    # with Capturing2() as c:
    # out = subprocess.check_output("cd ../examples/example_framework/instructor && python -m cs102.report2_grade", shell=True)
    out = subprocess.check_output("cd ../examples/example_framework/instructor && python -m cs102.report2_grade --noprogress", shell=True, encoding='utf8', errors='strict')
    out = out.replace("", "")
    out = out.replace("[0m", "")

    # out = out.decode("utf-8")
    with open("snips/deploy.txt", 'w') as f:
        f.write(out)
    # os.system("cd ../examples/example_framework/instructor && python -m cs102.report2_grade")

    data['bibtex'] = bib
    data = {**data, **dump_data("../examples")}

    data['resources'] = "https://gitlab.compute.dtu.dk/tuhe/unitgrade_private/-/raw/master"

    with open("README.jinja.md", 'r') as f:
        s = jinja2.Environment(loader=jinja2.FileSystemLoader([".", "../example"])).from_string(f.read()).render(data)
    with open("../README.md", 'w') as f:
        f.write(s)