import inspect, os
import shutil
import unitgrade_v1 as ug
from cs101courseware.cs101report1 import Report1
from unitgrade_private_v1.hidden_create_files import setup_answers, setup_grade_file_report
from unitgrade_v1.unitgrade_helpers import evaluate_report_student

if __name__ == "__main__":
    setup_answers(Report1())  # hidden for students; re-computes the answers file.
    setup_grade_file_report(Report1, minify=True, bzip=False, obfuscate=True)
    evaluate_report_student(Report1())

    # now copy scripts to public directory
    dest = os.path.join( os.path.dirname(inspect.getfile(ug)), "../cs101courseware_example")
    source = os.path.dirname(__file__)
    for f in os.listdir(source):
        if f == "__pycache__" or f.endswith(".token") or "deploy" in f or os.path.isdir(f):
            continue
        shutil.copy(f, dest)

    ## Report 2
    from cs101courseware.cs101report2 import Report2
    # from unitgrade_private_v1.hidden_create_files import setup_answers, setup_grade_file_report
    # from unitgrade_v1.unitgrade_helpers import evaluate_report_student
    setup_grade_file_report(Report2, minify=True, bzip=True, obfuscate=True)
    # evaluate_report_student(Report2())


