from unitgrade_v1.unitgrade import QuestionGroup, Report, QPrintItem, Hidden
from tutorial import shop

class AdditionQuestion(QuestionGroup):
    title = "Addition Test"
    class AdditionItem1(QPrintItem):
        a, b = 2,2
        def compute_answer_print(self):
            from tutorial.addition import add
            v = add(self.a, self.b)
            print(add(self.a, self.b))

    class AdditionItem2(AdditionItem1):
        a,b = -4, 2

    class AdditionItem3(AdditionItem1):
        a,b = -10, 2

class FruitListQuestion(QuestionGroup):
    title = "buy lots of fruit.py"
    class FruitListItem1(QPrintItem):
        fruit_list = [ ('apples', 2.0), ('pears',3.0), ('limes',4.0) ]
        def compute_answer_print(self):
            from tutorial.buyLotsOfFruit import buyLotsOfFruit
            print(buyLotsOfFruit(self.fruit_list))

    class FruitListItem2(FruitListItem1):
        fruit_list =  [('apples', 4.0), ('pears', 3.0), ('limes', 2.0)]

    class FruitListItem3(FruitListItem1):
        fruit_list = [('apples', 1.25), ('pears', 1.50), ('limes', 1.75)]


class FruitShops(QuestionGroup):
    title = "Find best shop for fruit shopping (shopSmart.py)"

    class FruitShopItem1(QPrintItem):
        shops = [shop.FruitShop('shop1',  {'apples': 2.0, 'oranges': 1.0}),
                 shop.FruitShop('shop2', {'apples': 1.0, 'oranges': 5.0})]
        order = [('apples', 1.0), ('oranges', 3.0)]

        def compute_answer_print(self):
            from tutorial.shopSmart import shopSmart
            print(shopSmart(self.order, self.shops))

    class FruitShopItem2(FruitShopItem1):
        order = [('apples', 3.0)]

    class FruitShopItem3(FruitShopItem1):
        shops = [shop.FruitShop('shop1', {'apples': 2.0, 'oranges': 1.0}),
                 shop.FruitShop('shop2', {'apples': 1.0, 'oranges': 5.0}),
                 shop.FruitShop('shop3',  {'apples': 1.5, 'oranges': 2.0})]
        order = [('apples',10.0), ('oranges',3.0)]


class FruitReport(Report):
    title = "Fruit and addition report"
    questions = [(AdditionQuestion, 1), (FruitListQuestion, 3), (FruitShops, 2) ]
    pack_imports = [] # Include this file in .token file

if __name__ == "__main__":
    # from unitgrade_private_v1.hidden_create_files import setup_answers, setup_grade_file_report
    from unitgrade_v1.unitgrade_helpers import evaluate_report_student
    from unitgrade_private_v1.hidden_create_files import setup_grade_file_report
    # setup_grade_file_report(FruitReport, minify=True, bzip=False, obfuscate=True)
    # evaluate_report_student(Report2())
    evaluate_report_student(FruitReport())


