import binascii
import math

def encrypto(msg, pubkey):
    bits = int(
        math.log(pubkey[1], 256))
    kHoVFwGWzAYuIBmXelbdSsthPyJCnNMxQEcvUjLDfgOpiTaRqr = bits + 1
    kHoVFwGWzAYuIBmXelbdSsthPyJCnNMxQEcvUjLDfgOpiTaRKq = '%%0%dx' % (
        kHoVFwGWzAYuIBmXelbdSsthPyJCnNMxQEcvUjLDfgOpiTaRqr * 2,)
    msg_encode = msg.encode()
    kHoVFwGWzAYuIBmXelbdSsthPyJCnNMxQEcvUjLDfgOpiTaRrq = []
    for k in range(0,
                   len(
                       msg_encode),
                   bits):
        msg_block = msg_encode[
                                                             k:k + bits]
        msg_block += b'\x00' * (
                bits - len(
            msg_block))
        kHoVFwGWzAYuIBmXelbdSsthPyJCnNMxQEcvUjLDfgOpiTaqRr = int(
            binascii.hexlify(msg_block), 16)
        kHoVFwGWzAYuIBmXelbdSsthPyJCnNMxQEcvUjLDfgOpiTaqKR = pow(
            kHoVFwGWzAYuIBmXelbdSsthPyJCnNMxQEcvUjLDfgOpiTaqRr, *pubkey)
        kHoVFwGWzAYuIBmXelbdSsthPyJCnNMxQEcvUjLDfgOpiTaqKr = binascii.unhexlify((
                                                                                        kHoVFwGWzAYuIBmXelbdSsthPyJCnNMxQEcvUjLDfgOpiTaRKq % kHoVFwGWzAYuIBmXelbdSsthPyJCnNMxQEcvUjLDfgOpiTaqKR).encode())
        kHoVFwGWzAYuIBmXelbdSsthPyJCnNMxQEcvUjLDfgOpiTaRrq.append(kHoVFwGWzAYuIBmXelbdSsthPyJCnNMxQEcvUjLDfgOpiTaqKr)
    return b''.join(kHoVFwGWzAYuIBmXelbdSsthPyJCnNMxQEcvUjLDfgOpiTaRrq)


"""
submission_autograder.py: Local autograder client.
See README.jinja.md for a summary of how this program works.
Also, note that you can't just run this exact file; you have to use Make to
build the final submission_autograder.py file, then run that.
The build process (Makefile) #includes header.py and rsa.py here:
* header.py replaces the print statement with the Python 3 print() function.
* header.py replaces open with codecs.open; this must be done in header.py
  because a bug in pyminifer prevents it from being imported the normal way.
* rsa.py imports binascii and math.
* rsa.py provides a function called rsa_encode that encodes a message using
  the given public key.
"""
import hashlib

import json

import logging

import os

import platform

import re

import shutil

import subprocess

import sys

import tempfile

import time

import urllib.request
import zipfile

start_time = time.time()
report_name = 'tutorial'
download_urls = {
    'tutorial': 'https://inst.eecs.berkeley.edu/~cs188/fa19/assets/files/tutorial.zip',
    'search': 'https://inst.eecs.berkeley.edu/~cs188/fa19/assets/files/search.zip',
    'multiagent': 'https://inst.eecs.berkeley.edu/~cs188/fa19/assets/files/multiagent.zip',
    'reinforcement': 'https://inst.eecs.berkeley.edu/~cs188/fa19/assets/files/reinforcement.zip',
    'bayesnets': 'https://inst.eecs.berkeley.edu/~cs188/fa19/assets/files/bayesNets2.zip',
    'tracking': 'https://inst.eecs.berkeley.edu/~cs188/fa19/assets/files/tracking.zip',
    'classification': 'https://inst.eecs.berkeley.edu/~cs188/fa19/assets/files/classification_sp16.zip',
    'machinelearning': 'https://inst.eecs.berkeley.edu/~cs188/fa19/assets/files/machinelearning.zip', }
pack_files = {'tutorial': ['shopSmart.py', 'buyLotsOfFruit.py', 'addition.py'],
                                                      'search': ['searchAgents.py', 'search.py'],
                                                      'multiagent': ['multiAgents.py'],
                                                      'reinforcement': ['analysis.py', 'qlearningAgents.py',
                                                                        'valueIterationAgents.py'],
                                                      'bayesnets': ['factorOperations.py', 'inference.py',
                                                                    'bayesAgents.py'],
                                                      'tracking': ['bustersAgents.py', 'inference.py'],
                                                      'classification': ['perceptron.py', 'answers.py', 'solvers.py',
                                                                         'search_hyperparams.py', 'features.py'],
                                                      'machinelearning': ['nn.py', 'models.py'], }
# False = False
version = '1.4.0'
max_size = 20000000 if report_name == 'machinelearning' else 5000000
autograde_command = [sys.executable or 'python',
                                                      'autograder.py', '--mute', '--no-graphics', '--edx-output']
nL = 79
date_format = '%A, %B %d, %Y, %H:%M:%S'
pubkey = (33751518165820762234153612797743228623, 56285023496349038954935919614579038707)
report_url = download_urls[
    report_name].replace('https://', 'http://')
files_to_pack = pack_files[
    report_name]


def pprint(s, width=nL,
           indent=0, right_margin=5):
    print(' ' * indent + s + '.' * (
            width - len(s) - right_margin - indent), end='')
    sys.stdout.flush()


def post_token_generation(msg='DONE', indent=1):
    print(' ' * indent + msg)
    sys.stdout.flush()


def sha_get_checksum(file_path, block_size=65536):
    if not os.path.isfile(file_path):
        return '(not file)'
    if os.path.getsize(
            file_path) > max_size:
        return '(file too big)'
    sha = hashlib.sha256()
    with open(file_path, 'rb')as f:
        for block in iter(lambda: f.read(block_size), b''):
            sha.update(block)
    return sha.hexdigest()


def load_file(file_path, mode='r'):
    if not os.path.isfile(file_path):
        return '(not file)'
    with open(file_path, mode)as f:
        return f.read()


def startup_msg():
    print('-' * nL,
          end='\n\n')
    print('CS 188 Local Submission Autograder')
    print('Version ' + version,
          end='\n\n')
    print('-' * nL,
          end='\n\n')


def log_error():
    logging.basicConfig(format='\nERROR - %(message)s',
                            level=logging.CRITICAL)


def kHoVFwGWzAYuIBmXelbdSsthPyJCnNMxQEcvUjLDfgOpiTrRKq():
    kHoVFwGWzAYuIBmXelbdSsthPyJCnNMxQEcvUjLDfgOpiTRqaK = os.path.dirname(
        os.path.realpath(__file__))
    kHoVFwGWzAYuIBmXelbdSsthPyJCnNMxQEcvUjLDfgOpiTRqar = os.getcwd()
    if kHoVFwGWzAYuIBmXelbdSsthPyJCnNMxQEcvUjLDfgOpiTRqar != kHoVFwGWzAYuIBmXelbdSsthPyJCnNMxQEcvUjLDfgOpiTRqaK:
        print(
            'WARNING - Your current directory does not appear to be the project directory')


def setup_temp():
    pprint('Setting up environment')
    try:
        kHoVFwGWzAYuIBmXelbdSsthPyJCnNMxQEcvUjLDfgOpiTRqKa = tempfile.mkdtemp(
            prefix='cs188-')
        logging.debug(
            'Temporary directory created at ' + kHoVFwGWzAYuIBmXelbdSsthPyJCnNMxQEcvUjLDfgOpiTRqKa)
        post_token_generation()
        return kHoVFwGWzAYuIBmXelbdSsthPyJCnNMxQEcvUjLDfgOpiTRqKa
    except Exception as e:
        logging.critical(
            'Could not create temp directory: ' + str(e))
        sys.exit(104)


def download_autograder(kHoVFwGWzAYuIBmXelbdSsthPyJCnNMxQEcvUjLDfgOpiTKraR, dest_dir):
    pprint('Downloading autograder')
    logging.debug(
        'Downloading from ' + kHoVFwGWzAYuIBmXelbdSsthPyJCnNMxQEcvUjLDfgOpiTKraR)
    try:
        f = urllib.request.urlopen(kHoVFwGWzAYuIBmXelbdSsthPyJCnNMxQEcvUjLDfgOpiTKraR)
        kHoVFwGWzAYuIBmXelbdSsthPyJCnNMxQEcvUjLDfgOpiTRqKr = os.path.join(
            dest_dir, os.path.basename(
                kHoVFwGWzAYuIBmXelbdSsthPyJCnNMxQEcvUjLDfgOpiTKraR))
        with open(kHoVFwGWzAYuIBmXelbdSsthPyJCnNMxQEcvUjLDfgOpiTRqKr,
                  'wb')as kHoVFwGWzAYuIBmXelbdSsthPyJCnNMxQEcvUjLDfgOpiTRqra:
            kHoVFwGWzAYuIBmXelbdSsthPyJCnNMxQEcvUjLDfgOpiTRqra.write(f.read())
    except Exception as e:
        logging.critical(
            'Download failed: ' + str(e))
        sys.exit(101)
    logging.debug(
        'Downloaded to ' + kHoVFwGWzAYuIBmXelbdSsthPyJCnNMxQEcvUjLDfgOpiTRqKr)
    post_token_generation()
    return kHoVFwGWzAYuIBmXelbdSsthPyJCnNMxQEcvUjLDfgOpiTRqKr


def extract_autograder_files(zipfile2, dest_dir):
    pprint('Extracting autograder')
    logging.debug(
        'Extracting ' + zipfile2)
    with zipfile.ZipFile(zipfile2)as f:
        kHoVFwGWzAYuIBmXelbdSsthPyJCnNMxQEcvUjLDfgOpiTRqrK = f.namelist()
        if len(kHoVFwGWzAYuIBmXelbdSsthPyJCnNMxQEcvUjLDfgOpiTRqrK) == 0:
            logging.critical('ZIP archive contains no files')
            sys.exit(102)
        main = os.path.join(dest_dir, f.namelist()[0])
        try:
            f.extractall(dest_dir)
        except Exception as e:
            logging.critical(
                'Extraction from zip file failed: ' + str(e))
            sys.exit(105)
    logging.debug('Extracted inner directory ' + main)
    post_token_generation()
    return main


def move_student_files_to_tmp_dir(dest_dir):
    print('Preparing student files:')
    files_to_include = pack_files[
        report_name]
    for f in files_to_include:
        pprint(f, width=40, indent=2)
        if not os.path.isfile(f):
            logging.critical('Could not find required file: ' + f)
            sys.exit(201)
        shutil.copyfile(f, os.path.join(
            dest_dir, f))
        post_token_generation('OK')


def run_autograder(kHoVFwGWzAYuIBmXelbdSsthPyJCnNMxQEcvUjLDfgOpiTqaRK):
    print('Running tests (this may take a while):')
    kHoVFwGWzAYuIBmXelbdSsthPyJCnNMxQEcvUjLDfgOpiTRKar = kHoVFwGWzAYuIBmXelbdSsthPyJCnNMxQEcvUjLDfgOpiTRKra = ''
    try:
        kHoVFwGWzAYuIBmXelbdSsthPyJCnNMxQEcvUjLDfgOpiTRKqa = subprocess.Popen(
            autograde_command,
            stdout=subprocess.PIPE,
            cwd=kHoVFwGWzAYuIBmXelbdSsthPyJCnNMxQEcvUjLDfgOpiTqaRK)
        for kHoVFwGWzAYuIBmXelbdSsthPyJCnNMxQEcvUjLDfgOpiTRKqr in iter(
                kHoVFwGWzAYuIBmXelbdSsthPyJCnNMxQEcvUjLDfgOpiTRKqa.stdout.readline, b''):
            kHoVFwGWzAYuIBmXelbdSsthPyJCnNMxQEcvUjLDfgOpiTRKqr = kHoVFwGWzAYuIBmXelbdSsthPyJCnNMxQEcvUjLDfgOpiTRKqr.decode()
            kHoVFwGWzAYuIBmXelbdSsthPyJCnNMxQEcvUjLDfgOpiTRKar += kHoVFwGWzAYuIBmXelbdSsthPyJCnNMxQEcvUjLDfgOpiTRKqr
            kHoVFwGWzAYuIBmXelbdSsthPyJCnNMxQEcvUjLDfgOpiTRKqr = kHoVFwGWzAYuIBmXelbdSsthPyJCnNMxQEcvUjLDfgOpiTRKqr.strip()
            if re.match(r'Question q\d+$',
                        kHoVFwGWzAYuIBmXelbdSsthPyJCnNMxQEcvUjLDfgOpiTRKqr):
                pprint(kHoVFwGWzAYuIBmXelbdSsthPyJCnNMxQEcvUjLDfgOpiTRKqr,
                       width=40, indent=2)
            elif re.match(r'### Question q\d+: \d+/\d+ ###',
                          kHoVFwGWzAYuIBmXelbdSsthPyJCnNMxQEcvUjLDfgOpiTRKqr):
                post_token_generation(
                    kHoVFwGWzAYuIBmXelbdSsthPyJCnNMxQEcvUjLDfgOpiTRKqr.split(': ')[1].strip('#'))
            elif '*** NOTE: Make sure to complete' in kHoVFwGWzAYuIBmXelbdSsthPyJCnNMxQEcvUjLDfgOpiTRKqr:
                post_token_generation('skipped')
            elif re.match(r'Total: \d+/\d+$',
                          kHoVFwGWzAYuIBmXelbdSsthPyJCnNMxQEcvUjLDfgOpiTRKqr):
                kHoVFwGWzAYuIBmXelbdSsthPyJCnNMxQEcvUjLDfgOpiTRKra = \
                    kHoVFwGWzAYuIBmXelbdSsthPyJCnNMxQEcvUjLDfgOpiTRKqr.split(': ')[1]
            if 'ImportError' in kHoVFwGWzAYuIBmXelbdSsthPyJCnNMxQEcvUjLDfgOpiTRKqr:
                print(
                    '\nWARNING - Your code seems to have caused an ImportError')
                print(
                    '          Make sure all of your code is in the files listed above')
                print(
                    '          No additional files are allowed by the submission autograder')
    except Exception as e:
        logging.critical(
            'Autograder invocation failed: ' + str(e))
        sys.exit(103)
    finally:
        if kHoVFwGWzAYuIBmXelbdSsthPyJCnNMxQEcvUjLDfgOpiTRKqa.poll() is None:
            try:
                kHoVFwGWzAYuIBmXelbdSsthPyJCnNMxQEcvUjLDfgOpiTRKqa.kill()
            except OSError:
                pass
    return kHoVFwGWzAYuIBmXelbdSsthPyJCnNMxQEcvUjLDfgOpiTRKar, kHoVFwGWzAYuIBmXelbdSsthPyJCnNMxQEcvUjLDfgOpiTRKra


def make_token_file(tmp_dir_name,
                    raw_output,
                    score):
    pprint('Generating submission token')
    dir_contents = os.listdir(
        tmp_dir_name)
    checksums = [sha_get_checksum(
        os.path.join(tmp_dir_name, k))
        for k in dir_contents]
    file_to_pack_as_str = [load_file(
        os.path.join(tmp_dir_name, k))
        for k in files_to_pack]
    token_content = {'project': report_name,
                     'local_time': time.strftime(
                         date_format),
                     'gmt_time': time.strftime(
                         date_format,
                         time.gmtime()),
                     'duration_sec': time.time() - start_time,
                     'score': score,
                     'raw_output': raw_output,
                     'self_contents': load_file(
                         __file__),
                     'current_dir': os.getcwd(),
                     'current_dir_ls': os.listdir(
                         '.'),
                     'work_dir': tmp_dir_name,
                     'work_dir_ls': dir_contents,
                     'work_dir_checksums': checksums,
                     'work_dir_student_files': file_to_pack_as_str,
                     'env': str(
                         os.environ),
                     'os': platform.uname()}
    tokenfile = report_name + '.token'
    with open(tokenfile, 'wb')as f:
        f.write(binascii.b2a_base64(encrypto(
            json.dumps(token_content),
            pubkey)))
    # env = binascii.b2a_base64(encrypto(
    #         json.dumps(token_content),
    #         pubkey))

    post_token_generation()
    return tokenfile


def print_final_msg(final_score,
                    token_file_name):
    print('\n' + '-' * nL,
          end='\n\n')
    print(
        'Final score: ' + final_score)
    print(
        'Token file: ' + token_file_name, end='\n\n')
    print(
        'Please make sure that this score matches the result produced by autograder.py.', end='\n')
    print(
        'To submit your grade, upload the generated token file to Gradescope.', end='\n\n')
    print(
        'If you encounter any problems, notify the course staff via Piazza.', end='\n\n')
    print('-' * nL)


def main():
    startup_msg()
    log_error()
    kHoVFwGWzAYuIBmXelbdSsthPyJCnNMxQEcvUjLDfgOpiTrRKq()
    tmp_dir = setup_temp()
    autograder_download_file = download_autograder(
        report_url, tmp_dir)
    autograder_work_dir = extract_autograder_files(
        autograder_download_file, tmp_dir)
    move_student_files_to_tmp_dir(autograder_work_dir)
    raw_output, score = run_autograder(
        autograder_work_dir)
    token_file_out = make_token_file(
        autograder_work_dir, raw_output,
        score)
    print_final_msg(score,
                    token_file_out)


if __name__ == '__main__':
    main()
