from unitgrade_v1.unitgrade import QuestionGroup, QItem, Report, QPrintItem
from unitgrade_v1.unitgrade_helpers import evaluate_report_student

class AlgebraQuestionGroup(QuestionGroup):
    title = "Graph search"
    class AdditionQuestion(QItem):
        title = "Testing addition"
        def compute_answer(self):
            return 4 + 6

    class MultiplicationQuestion(QItem):
        title = "Testing multiplication"
        def compute_answer(self):
            return 2*12

    class ComplicatedQuestion(QPrintItem):
        def compute_answer_print(self):
            print("The answer is 43.5 and 23434 and -23.4 asdf")

        def process_output(self, res, txt, numbers):
            return txt

class Week1QuestionGroup(QuestionGroup):
    title = "Week 1: Simple DP"
    class ChessTournamentQuestion(QPrintItem):
        tol = 0.05
        testfun = QPrintItem.assertL2Relative
        def compute_answer_print(self):
            from irlc.ex01.chess import main
            main()
        def process_output(self, res, txt, numbers):
            return numbers

    class GraphTraversalQuestion(QPrintItem):
        def compute_answer_print(self):
            from irlc.ex02 import graph_traversal
            graph_traversal.main()

class Report0(Report):
    title = "Example report script"
    questions = [(AlgebraQuestionGroup, 1), (Week1QuestionGroup, 3)]

if __name__ == "__main__":
    from unitgrade_v1.hidden_create_files import setup_answers
    setup_answers(Report0())
    evaluate_report_student(Report0())
