from unitgrade.evaluate import evaluate_report
from tabulate import tabulate
from datetime import datetime
import inspect
import json
import os
import bz2
import pickle
import os
import unitgrade.evaluate


def bzwrite(json_str, token): # to get around obfuscation issues
    with getattr(bz2, 'open')(token, "wt") as f:
        f.write(json_str)

def gather_imports(imp):
    resources = {}
    m = imp
    # for m in pack_imports:
    # print(f"*** {m.__name__}")
    f = m.__file__
    # dn = os.path.dirname(f)
    top_package = os.path.dirname(__import__(m.__name__.split('.')[0]).__file__)
    # top_package = os.path.dirname(__import__(m.__name__.split('.')[0]).__file__)
    top_package = os.path.dirname(top_package)

    if f.endswith("__init__.py"):
        for root, dirs, files in os.walk(os.path.dirname(f)):
            for file in files:
                if file.endswith(".py"):
                    # print(file)
                    # print()
                    v = os.path.relpath(os.path.join(root, file), top_package)
                    with open(os.path.join(root, file), 'r') as ff:
                        resources[v] = ff.read()
    else:
        v = os.path.relpath(f, top_package)
        with open(f, 'r') as ff:
            resources[v] = ff.read()
    return resources


def gather_upload_to_campusnet(report, output_dir=None):
    n = 80
    results, table_data = evaluate_report(report, show_help_flag=False, show_expected=False, show_computed=False, silent=True)
    print(" ")
    print("="*n)
    print("Final evaluation")
    print(tabulate(table_data))
    # also load the source code of missing files...

    if len(report.individual_imports) > 0:
        print("By uploading the .token file, you verify the files:")
        for m in report.individual_imports:
            print(">", m.__file__)
        print("Are created/modified individually by you in agreement with DTUs exam rules")
        report.pack_imports += report.individual_imports

    sources = {}
    if len(report.pack_imports) > 0:
        print("Including files in upload...")
        for m in report.pack_imports:
            nimp  = gather_imports(m)
            if len([k for k in nimp if k not in sources]) > 0:
                print(f"*** {m.__name__}")
            sources = {**sources, **nimp}
    results['sources'] = sources

    json_str = json.dumps(results, indent=4)

    if output_dir is None:
        output_dir = os.getcwd()

    payload_out_base = report.__class__.__name__ + "_handin"

    obtain, possible = results['total']
    vstring = "_v"+report.version if report.version is not None else ""

    token = "%s_%i_of_%i%s.token"%(payload_out_base, obtain, possible,vstring)
    token = os.path.join(output_dir, token)
    bzwrite(json_str, token)

    print(" ")
    print("To get credit for your results, please upload the single file: ")
    print(">", token)
    print("To campusnet without any modifications.")

def source_instantiate(name, report1_source, payload):
    eval("exec")(report1_source, globals())
    pl = pickle.loads(bytes.fromhex(payload))
    report = eval(name)(payload=pl, strict=True)
    # report.set_payload(pl)
    return report
