import numpy as np

def thermoEquilibrium(N, r): # ok
    Nl = N
    for t, rand in enumerate(r):
        Plr = Nl / N
        Nl += (-1 if rand < Plr else 1)
        if Nl == N//2:
            break
    t = t + 1 if N//2 == Nl else 0
    return t

def circleAreaMC(xvals, yvals):
    X = np.stack([np.asarray(xvals), np.asarray(yvals)], 1)
    A = (np.sum(X ** 2, 1) < 1.0 ).sum() / len(xvals) * 4
    return A

def convertTemperature(T, unitFrom, unitTo):
    C, F, K = 'Celsius', 'Fahrenheit', 'Kelvin'
    def x2K(temp, unit):
        if unit == F: return (temp + 459.67) / 1.8
        if unit == C: return temp + 273.15
        return temp

    def K2x(temp, unit):
        if unit == C: return temp - 273.15
        if unit == F: return 1.8 * temp - 459.67
        return temp
    T = K2x(x2K(T, unitFrom), unitTo)
    return T

if __name__ == "__main__":
    print("convertTemperature should return 10. Your output:")
    print(convertTemperature(50.0, "Fahrenheit", "Celsius"))

    print("circleAreaMC should return 3.2. Your output:")
    print(circleAreaMC(np.array([-0.1, 0.7, 0.8, 0.5, -0.4]), np.array([0.3, -0.1, 0.9, 0.6, -0.3])))

    print("thermoEquilibrium should return 1. Your output:")
    print(thermoEquilibrium(2.0, np.array([0.16, 0.04, 0.72,
                                           0.09, 0.17, 0.60, 0.26, 0.65, 0.69, 0.74, 0.45, 0.61,
                                           0.23, 0.37, 0.15, 0.83, 0.61, 1.00, 0.08, 0.44])))
