from unitgrade_private.autolab.autolab import deploy_assignment
from unitgrade_private.docker_helpers import download_docker_images
from unitgrade_private.docker_helpers import compile_docker_image

if __name__ == "__main__":
    # Step 1: Download and compile docker grading image. You only need to do this once.  #!s=a
    download_docker_images("./docker") # Download docker images from gitlab (only do this once.
    dockerfile = f"./docker/docker_tango_python/Dockerfile"
    autograde_image = 'tango_python_tue'
    compile_docker_image(Dockerfile=dockerfile, tag=autograde_image)  # Compile docker image. #!s

    # Step 2: Create the cs102.tar file from the grade scripts. #!s=b
    instructor_base = f"../example_framework/instructor"
    student_base = f"../example_framework/students"
    output_tar = deploy_assignment("cs102",  # Autolab name of assignment (and name of .tar file)
                                   INSTRUCTOR_BASE=instructor_base,
                                   INSTRUCTOR_GRADE_FILE=f"{instructor_base}/cs102/report2_grade.py",
                                   STUDENT_BASE=student_base,
                                   STUDENT_GRADE_FILE=f"{student_base}/cs102/report2_grade.py",
                                   autograde_image_tag=autograde_image) #!s

    # output_tar is now the `cs102.tar` which can be uploaded to autolab as a lab-assignment.
