from unitgrade_private.docker_helpers import docker_run_token_file
import os
import glob
import pickle
import time

""" Run all examples on docker. """

if __name__ == "__main__":
    # Step 0: Compile our two docker images.
    from unitgrade_private.docker_helpers import compile_docker_image

    docker_files = [f"{os.getcwd()}/../../docker_images/unitgrade-docker/Dockerfile"]
    docker_tags = []
    for f in docker_files:
        tag = compile_docker_image(f)
        docker_tags.append( (f, tag) )

    EX_BASE =  f"{os.getcwd()}/../" # Base of examples.

    runs = [
        ("example_flat", "programs", "programs/report1flat_grade.py", "programs", "programs/report1flat_grade.py",),
        ("example_simplest", "", "cs101/report1_grade.py", "", "cs101/report1_grade.py", ),
        ("example_framework", "", "cs102/report2_grade.py", "", "cs102/report2_grade.py", ),
        ("example_docker", "", "cs103/report3_complete_grade.py", "", "cs103/report3_grade.py",),
             ]
    rs = []

    def p2mod(file, base):
        return ".".join(os.path.normpath(os.path.relpath(file, base)).split(os.sep))[:-3]
    start = time.time()
    for ex, ibase, ig, sbase, sg in runs:
        ibase = f"{EX_BASE}/{ex}/instructor/{ibase}"
        ig = f"{EX_BASE}/{ex}/instructor/{ig}"
        sbase = f"{EX_BASE}/{ex}/students/{sbase}"
        sg = f"{EX_BASE}/{ex}/students/{sg}"

        # Uncomment to run example deployment scripts:
        # os.system(f"cd {ibase} && python -m {p2mod(os.path.dirname(ig) + '/deploy.py', ibase)}")

        os.system(f"cd {sbase} && python -m { p2mod(sg, sbase) }")
        stoken = glob.glob(f"{os.path.dirname(sg)}/*.token")[0]

        Dockerfile, tag = docker_tags[0] # Get first docker file.
        token = docker_run_token_file(Dockerfile_location=Dockerfile,
                                      host_tmp_dir=os.path.dirname(Dockerfile) + "/tmp",
                                      student_token_file=stoken,
                                      instructor_grade_script=ig)
        with open(token, 'rb') as f:
            iresults = pickle.load(f)
        with open(stoken, 'rb') as f:
            sresults = pickle.load(f)
        rs.append( (ex, sresults, iresults) )

    for ex, sresults, iresults in rs:
        print( f"[{ex}]", "Student's score was:", sresults['total'], "score using my eval script", iresults['total'])
    print("Total elapsed time", time.time()-start, "seconds")