from unitgrade import UTestCase, Report, cache
from cpp_course.fractions import from_string, Fraction

class Fractions_from_string(UTestCase):
    def test_from_string_manual(self):
        self.assertEqual(str(from_string("2 / 3 + 4 / 5")), "22 / 6")

    def test_from_string_smarter(self):
        self.assertEqualC(str(from_string("2 / 3 + 4 / 5")))

    @cache
    def output(self, problem):
        return from_string(problem)

    def test_from_string_smartest(self):
        problems = """
        2 / 3 + 4 / 5
        1 / 2 * 3 / 4
        1 / 2 div 1 / 2
        1 / 4 + 1 / 2
        1 / 2 * 2 / 4
        1 / 2 div 4 / 2"""
        print("\nTesting a bunch of problems...")
        for l in problems.strip().splitlines():
            l = l.strip() # Remove trailing spaces
            print(f"Testing from_string({l}), output ought to be: {self.output(l)}")
            self.assertEqualC(str(from_string(l))) # Actually perform the test.

class Fractions_Basics(UTestCase):
    def test_addition(self):
        f1 = Fraction(1, 2)  # Represents 1/2
        f2 = Fraction(3, 5)  # Represents 3/5
        self.assertEqualC(str(f1 + f2))

    def test_multiplication(self):
        f1 = Fraction(1, 2)  # Represents 1/2
        f2 = Fraction(3, 5)  # Represents 3/5
        self.assertEqualC(str(f1 * f2))

    def test_division(self):
        f1 = Fraction(1, 2)  # Represents 1/2
        f2 = Fraction(3, 5)  # Represents 3/5
        self.assertEqualC(str(f1 / f2))


import cpp_course
class Week6(Report):
    title = "02393 Programming in C++: Problem set 6"
    pack_imports = [cpp_course]
    questions = [(Fractions_from_string, 10), (Fractions_Basics, 10)]

if __name__ == "__main__":
    from unitgrade import evaluate_report_student
    evaluate_report_student(Week6())
