class Vector:
    def __init__(self, x, y):
        self.x, self.y = x, y

def createField(m, n, v): #!f Create and return a field of the form [ [v11, v12,...], [v21, v22,...],...] here
    return [[Vector(v.x, v.y) for j in range(n)] for i in range(m)]

def displayField(A): #!f Compute and return a string representation of A (see problem description)
    return "\n".join([' '.join([f"({v.x},{v.y})" for v in c]) for c in A])

def addFields(A, B): #!f Create and return a new field corresponding to A+B (element-wise)
    return [ [Vector(v1.x + v2.x, v1.y+v2.y) for v1, v2 in zip(c1,c2) ] for c1,c2 in zip(A,B)]

def scaleField(A, s):  #!f Create and return a new field corresponding to A*s (element-wise)
    return [[Vector(v1.x * s, v1.y*s) for v1 in c1] for c1 in A]

if __name__ == "__main__":
    A = createField(3, 3, Vector(1,2)) #!s #!o
    A[1][1] = Vector(2,2)
    print(displayField(A))
    print( )
    B = createField(3, 3, Vector(2,-2))
    B[0][0] = B[2][2] = Vector(9, 8)
    print(displayField(B))
    print( )
    print(displayField(addFields(A, B)))
    print("Result of scaling A by 2")
    print(displayField(scaleField(A, 2))) #!s #!o


