class Elem:
    def __init__(self, value, times, next):
        self.value = value
        self.times = times
        self.next = next

def displayRLEList(l):
    if l is None: return ""
    return f" {l.value} (x{l.times})" +  displayRLEList(l.next)

def reverse(l): #!f
    prev = None
    current = l
    while current is not None:
        n = current.next
        prev = Elem(current.value, current.times, prev)
        current = n
    return prev

def concatenate(l1, l2): #!f
    hd = l1
    while l1.next is not None:
        l1 = l1.next
    l1.next = l2
    return hd

def rle_sum(l): #!f
    return 0 if l is None else (l.value * l.times + rle_sum(l.next))

if __name__ == "__main__":
    l1 = Elem(4, 10, Elem(12, 6, Elem(10, 5, None)))
    l2 = Elem(1, 1, Elem(2, 2, Elem(3, 3, None)))

    print("The RLE list is: ", displayRLEList(l1))
    print("Other is: ", displayRLEList(l2))

    print("The reversed list is: ", displayRLEList(reverse(l1)))
    print("After concatenation, the list is: ", displayRLEList(concatenate(l1, l2)))
    print("The sum of its elements is: ", rle_sum(l1))
