class Buffer:
    def __init__(self, default=-999): #!f
        self.buffer = []
        self.known = set()
        self.default = default

    def write(self, n): #!f
        if n not in self.known:
            self.buffer.insert(0, n)
            self.known.add(n)

    def reset(self): #!f
        self.buffer.clear()
        self.known.clear()

    def occupancy(self): #!f
        return len(set(self.buffer))

    def read(self): #!f
        return self.buffer.pop() if len(self.buffer) > 0 else self.default

if __name__ == "__main__":
    b = Buffer()
    print("Current buffer occupancy: ", b.occupancy())
    print("Reading from the buffer returns: ", b.read())

    for i in range(10):
        b.write(i*10)

    print("Current buffer occupancy: ", b.occupancy())
    for i in range(10):
        b.write(20)
    print("Current buffer occupancy: ", b.occupancy())
    for _ in range(3):
        print("Reading from the buffer returns: ", b.read())
    print("Current buffer occupancy: ", b.occupancy())
    b.reset()
    print("Current buffer occupancy: ", b.occupancy())
    print("Reading from the buffer returns: ", b.read())
