import numpy as np

def tictactoe(board):
    def wins(b):
        return(np.all(b, axis=0).sum() + np.all(b, axis=1).sum() + 
                 np.all(b.ravel()[[0,4,8]]) + np.all(b.ravel()[[2,4,6]]))
    
    ones_wins = wins(board==1)
    twos_wins = wins(board==2)
    d = np.sum(board==1) - np.sum(board==2)  #  0 or 1 for a valid board
    
    if d<0 or d>1 or (ones_wins + twos_wins) > 1:
        score = -1
    elif ones_wins:
        score = 1
    elif twos_wins:
        score = 2
    else:
        score=0    
    return score